{===EZDSLOPT.INC======================================================

Fixed compiler options for the EZ Delphi Structures Library.
DO NOT MODIFY ANYTHING IN THIS FILE.

EZDSLOPT.INC is Copyright (c) 1995-1999 by Julian M. Bucknall

VERSION HISTORY
24Oct99 JMB 3.02 Release for Delphi 4 & 5
26Sep97 JMB 3.00 Major new version, release for Delphi 3
13Mar96 JMB 1.00 release for Delphi 2.0
{=====================================================================}

{ Check for Delphi }
{$IFNDEF VER80} {$IFNDEF VER90}
  {$IFNDEF VER100} {$IFNDEF VER120}
    {$IFNDEF VER130}
//!! Error - EZDSL is for Delphi 1.0, 2.0, 3.0, 4.0 or 5.0 *only*
{$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF}

{------Fixed compiler options throughout EZDSL------------------------}

{---Delphi 1.0 specific---}
{$IFDEF VER80}
{$B-   Short-circuit boolean expressions }
{$G+   80286+ type instructions }
{$I+   I/O checking via exceptions }
{$V-   Disable var string checking }
{$W-   No Windows realmode stack frame }
{$X+   Enable extended syntax }
{$IFDEF DEBUG}
{$D+,L+  Enable debug information }
{$ELSE}
{$D-,L-  Disable debug information }
{$ENDIF}
{$ENDIF}

{---Delphi 2.0 specific---}
{$IFDEF VER90}
{$A+   Use DWORD alignment whereever possible }
{$B-   Short-circuit boolean expressions }
{$I+   I/O checking via exceptions }
{$V-   Disable var string checking }
{$W-   No Windows realmode stack frame }
{$X+   Enable extended syntax }
{$IFDEF DEBUG}
{$D+,L+  Enable debug information }
{$ELSE}
{$D-,L-  Disable debug information }
{$ENDIF}
{$ENDIF}

{---Delphi 3.0 specific---}
{$IFDEF VER100}
{$A+   Use DWORD alignment whereever possible }
{$B-   Short-circuit boolean expressions }
{$I+   I/O checking via exceptions }
{$V-   Disable var string checking }
{$W-   No Windows realmode stack frame }
{$X+   Enable extended syntax }
{$IFDEF DEBUG}
{$D+,L+  Enable debug information }
{$ELSE}
{$D-,L-  Disable debug information }
{$ENDIF}
{$ENDIF}

{---Delphi 4.0 specific---}
{$IFDEF VER120}
{$A+   Use DWORD alignment whereever possible }
{$B-   Short-circuit boolean expressions }
{$I+   I/O checking via exceptions }
{$V-   Disable var string checking }
{$W-   No Windows realmode stack frame }
{$X+   Enable extended syntax }
{$IFDEF DEBUG}
{$D+,L+  Enable debug information }
{$ELSE}
{$D-,L-  Disable debug information }
{$ENDIF}
{$ENDIF}

{---Delphi 5.0 specific---}
{$IFDEF VER130}
{$A+   Use DWORD alignment whereever possible }
{$B-   Short-circuit boolean expressions }
{$I+   I/O checking via exceptions }
{$V-   Disable var string checking }
{$W-   No Windows realmode stack frame }
{$X+   Enable extended syntax }
{$IFDEF DEBUG}
{$D+,L+  Enable debug information }
{$ELSE}
{$D-,L-  Disable debug information }
{$ENDIF}
{$ENDIF}

{---Hints and Warnings for 32-bit Delphi}
{$IFNDEF VER80}
{$WARNINGS ON}
{$HINTS ON}
{$ENDIF}
{---------------------------------------------------------------------}

