unit UDlgOpPrmClusEMSelection;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UDlgBaseOperatorParameter, ComCtrls, StdCtrls, ExtCtrls,
  lmdstdcA;

type
  TDlgOpPrmClusEMSelection = class(TDlgBaseOperatorParameter)
    Label1: TLabel;
    cmbCriterion: TComboBox;
    chkUpdate: TCheckBox;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    spinStart: TLMDSpinEdit;
    spinEnd: TLMDSpinEdit;
    rgEvalType: TRadioGroup;
    spinFold: TLMDSpinEdit;
    rgRnd: TRadioGroup;
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure   ApplyModifications(); override;
    procedure   SetParameters(); override;    
  end;

var
  DlgOpPrmClusEMSelection: TDlgOpPrmClusEMSelection;

implementation

uses UCompClusteringEMSelection, UCalcRndGenerator;

{$R *.dfm}

{ TDlgOpPrmClusEMSelection }

procedure TDlgOpPrmClusEMSelection.ApplyModifications;
var prm: TOpPrmClusEMSelection;
begin
 prm:= self.OpPrm as TOpPrmClusEMSelection;
 prm.Criterion:= TEnumCriterionEMSelection(self.cmbCriterion.ItemIndex);
 prm.UpdateEMClustering:= self.chkUpdate.Checked;
 prm.StartClus:= self.spinStart.Value;
 prm.EndClus:= self.spinEnd.Value;
 //test cohrence...
 if (prm.EndClus < prm.StartClus) then prm.EndClus:= prm.StartClus;
 //suite rcupration
 prm.EvalType:= self.rgEvalType.ItemIndex;
 prm.NbFolds:= self.spinFold.Value;
 prm.Random:= TStartSeed(self.rgRnd.ItemIndex);
end;

procedure TDlgOpPrmClusEMSelection.SetParameters;
var prm: TOpPrmClusEMSelection;
begin
 prm:= self.OpPrm as TOpPrmClusEMSelection;
 self.cmbCriterion.ItemIndex:= ord(prm.Criterion);
 self.chkUpdate.Checked:= prm.UpdateEMClustering;
 self.spinStart.Value:= prm.StartClus;
 self.spinEnd.Value:= prm.EndClus;
 self.rgEvalType.ItemIndex:= prm.EvalType;
 self.spinFold.Value:= prm.NbFolds;
 self.rgRnd.ItemIndex:= ord(prm.Random);
end;

end.
