(*************************************************************)
(* UFrmOpClusHAC.pas - Copyright (c) 2006 Ricco RAKOTOMALALA *)
(*************************************************************)

{
@abstract(Dessin du dendrogramme)
@author(Ricco)
@created(17/06/2006)
}

unit UFrmOpClusHAC;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ComCtrls, ExtCtrls, TeEngine,
  Series, TeeProcs, Chart, UCompClusteringHAC, LMDCustomComponent,
  LMDCustomHint, LMDCustomShapeHint, LMDMessageHint;

type
  TFrmOpViewClusHAC = class(TFrmBaseOperator)
    tabDendrogram: TTabSheet;
    chart: TChart;
    dendrogram: TPointSeries;
    messageHint: TLMDMessageHint;
    procedure actCopyExecute(Sender: TObject);
    procedure chartClickSeries(Sender: TCustomChart; Series: TChartSeries;
      ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
  private
    { Dclarations prives }
    FCalc: TCalcHAC;
    procedure drawDendro(Sender: TObject);
    procedure drawToLeaves(node: TNodeHAC);
  public
    { Dclarations publiques }
    procedure   PrepareView(); override;
  end;

var
  FrmOpViewClusHAC: TFrmOpViewClusHAC;

implementation

{$R *.dfm}

{ TFrmOpClusHAC }

procedure TFrmOpViewClusHAC.drawDendro(Sender: TObject);
begin
 chart.Canvas.Pen.Color:= clBlue;
 chart.Canvas.Pen.Width:= 2;
 self.drawToLeaves(FCalc.SetNodeHAC.RootNode);
end;

procedure TFrmOpViewClusHAC.drawToLeaves(node: TNodeHAC);
var sommet,left,right: TPoint;

   function coord(node: TNodeHAC): TPoint;
   begin
    result:= Point(dendrogram.CalcXPosValue(node.XPos),dendrogram.CalcYPosValue(node.YPos));
   end;

begin
 //pas une feuille ?
 if not(node.isLeaf())
  then
   begin
    sommet:= coord(node);
    left:= coord(node.ChildL);
    right:= coord(node.ChildR);
    chart.Canvas.Line(sommet.X,sommet.Y,left.X,sommet.Y);
    chart.Canvas.Line(left.X,sommet.Y,left.X,left.Y);
    chart.Canvas.Line(sommet.X,sommet.Y,right.X,sommet.Y);
    chart.Canvas.Line(right.X,sommet.Y,right.X,right.Y);
    //dessiner sur les feuilles
    self.drawToLeaves(node.ChildL);
    self.drawToLeaves(node.ChildR);
   end;
end;

procedure TFrmOpViewClusHAC.PrepareView;
var i: integer;
    node: TNodeHAC;
begin
 inherited;
 //rcuprer l'oprateur de calcul -- bien transtyper pour prvenir les erreurs
 FCalc:= (self.Operator as TOpClusHAC).CalcClustering as TCalcHAC;
 //modifier la page active
 self.pgctrlFond.ActivePage:= self.tabHTML;
 //remplir le graphique
 dendrogram.Clear();
 for i:= 0 to pred(FCalc.SetNodeHAC.getCountNodes()) do
  begin
   node:= FCalc.SetNodeHAC.getNode(i);
   if node.isCluster
    then dendrogram.AddXY(node.XPos,node.YPos,node.getLabel(),clWhite)
    else dendrogram.AddXY(node.XPos,node.YPos,node.getLabel(),clBlue);
  end;
 //gestionnaire de dessin du dendrogramme
 //dendrogram.AfterDrawValues:= drawDendro;
 //>>new -- 19/07/2006 -- pas mal a, on distingue mieux les noeuds !!!
 dendrogram.BeforeDrawValues:= drawDendro;
end;

procedure TFrmOpViewClusHAC.actCopyExecute(Sender: TObject);
begin
 if (self.pgctrlFond.ActivePage = self.tabHTML)
  then inherited
  else chart.CopyToClipboardMetafile(false);
end;

procedure TFrmOpViewClusHAC.chartClickSeries(Sender: TCustomChart;
  Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var coord: TPoint;
begin
 if (Series = dendrogram) and (ValueIndex >= 0)
  then
   begin
    coord:= chart.ClientToScreen(point(X,Y));
    messageHint.ShowMessage(dendrogram.ValueMarkText[ValueIndex],coord.X,coord.Y);
   end;
end;

end.
