unit UFrmOpClusTree;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ComCtrls, ExtCtrls, TeEngine,
  Series, TeeProcs, Chart, LMDCustomComponent, LMDCustomHint,
  LMDCustomShapeHint, LMDMessageHint;

type
  TfrmOpViewClusteringTree = class(TFrmBaseOperator)
    tabChart: TTabSheet;
    chart: TChart;
    growing: TLineSeries;
    pruning: TLineSeries;
    msgHint: TLMDMessageHint;
    procedure growingClick(Sender: TChartSeries; ValueIndex: Integer;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure actCopyExecute(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure   PrepareView(); override;
  end;

var
  frmOpViewClusteringTree: TfrmOpViewClusteringTree;

implementation

uses UCompClusteringTreeCART, UCalcClusteringTreeCART, UCalcClusteringTree;

{$R *.dfm}

procedure TfrmOpViewClusteringTree.growingClick(Sender: TChartSeries;
  ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
var coord: TPoint;
    msg: string;
begin
 coord:= chart.ClientToScreen(point(X,Y));
 msg:= Format('# leaves : %.0f -- Within p.s. : %.4f',[sender.XValues[ValueIndex],sender.YValues[ValueIndex]]);
 msgHint.ShowMessage(msg,coord.X,coord.Y);
end;

procedure TfrmOpViewClusteringTree.actCopyExecute(Sender: TObject);
begin
 if (self.pgctrlFond.ActivePageIndex = 0)
  then inherited
  else chart.CopyToClipboardBitmap();
end;

procedure TfrmOpViewClusteringTree.PrepareView;
var tree: TMLTreeStructureClusCTP;
    i: integer;
begin
 inherited;
 tree:= ((self.Operator as TOpClusTreeCART).CalcClustering as TCalcClusTreeCTP).Tree as TMLTreeStructureClusCTP;
 for i:= low(tree.TabTreeSequence) to high(tree.TabTreeSequence) do
  begin
   growing.AddXY(tree.TabTreeSequence[i].NbLeaves,tree.TabTreeSequence[i].wssGrow);
   pruning.AddXY(tree.TabTreeSequence[i].NbLeaves,tree.TabTreeSequence[i].wssPrune);
  end;
 self.pgctrlFond.ActivePageIndex:= 0;
end;

end.
