(*******************************************************************)
(* UCompSDMoodRunsTest.pas - Copyright (c) 2004 Ricco RAKOTOMALALA *)
(*******************************************************************)

{
@abstract(Comparaison de 2 populations, mais avec une approche non paramtrique, celle de Wald & Wolfowitz)
@author(Ricco)
@created(17/07/2005)

Attention, nous utilisons les rangs alatoires dans le cas des ex-aequos dans cette implmentation.

}
unit UCompSDWaldWolfowitzRunsTest;

interface

USES
   UCompDefinition, UOperatorDefinition,
   UCompSDCondDescDefinition,
   UCalcStatDesConditionnalDesc;

TYPE
   //gnrateur
   TMLGenCompSDWWRunsTest = class(TMLGenComp)
                              protected
                              procedure   GenCompInitializations(); override;
                              public
                              function    GetClassMLComponent: TClassMLComponent; override;
                              end;

   //composant
   TMLCompSDWWRunsTest = class(TMLCompSDCondDescDefinition)
                           protected
                           function    getClassOperator: TClassOperator; override;
                           end;

   //oprateur
   TOpSDWWRunsTest = class(TOpSDCondDescDefinition)
                       protected
                       function    getClassStat(): TClassCalcSDCondDesc; override;
                       function    getClassLstStat(): TClassLstCalcStatDesCond; override;
                       function    getClassParameter: TClassOperatorParameter; override;
                       end;

   //paramtrage
   TOpSDPrmWWRunsTest = class(TOpPrmSDCondDescDefinition)
                          end;


implementation

USES
   Classes, Sysutils,
   UDatasetDefinition, UDatasetImplementation,
   UCalcStatDesCondDescRuns;

{ TMLGenCompSDWWRunsTest }

procedure TMLGenCompSDWWRunsTest.GenCompInitializations;
begin
 FMLComp:= mlcNonParametricStatistics;
end;

function TMLGenCompSDWWRunsTest.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompSDWWRunsTest; 
end;

{ TMLCompSDWWRunsTest }

function TMLCompSDWWRunsTest.getClassOperator: TClassOperator;
begin
 result:= TOpSDWWRunsTest;
end;

{ TOpSDWWRunsTest }

function TOpSDWWRunsTest.getClassLstStat: TClassLstCalcStatDesCond;
begin
 result:= TLstCalcStatDesCondRunsWW;
end;

function TOpSDWWRunsTest.getClassParameter: TClassOperatorParameter;
begin
 result:= TOpSDPrmWWRunsTest;
end;

function TOpSDWWRunsTest.getClassStat: TClassCalcSDCondDesc;
begin
 result:= TCalcSDRunsWaldWolfowitz;
end;

initialization
 RegisterClass(TMLGenCompSDWWRunsTest);
end.
