(**********************************************************************)
(* UCompSDVarTestBartlett.pas - Copyright (c) 2005 Ricco RAKOTOMALALA *)
(**********************************************************************)

{
@abstract(Comparaison de K variances -- Test de Bartlett)
@author(Ricco)
@created(22/07/2005)

Comparaison de K variances (chantillons indpendants et normaux)

}

unit UCompSDVarTestBartlett;

interface

USES
   UCompDefinition, UOperatorDefinition,
   UCompSDCondDescDefinition,
   UCalcStatDesConditionnalDesc,
   UCalcStatDesVarianceHomogeneity;

TYPE
   //gnrateur
   TMLGenCompSDVarTestBartlett = class(TMLGenComp)
                               protected
                               procedure   GenCompInitializations(); override;
                               public
                               function    GetClassMLComponent: TClassMLComponent; override;
                               end;

   //composant
   TMLCompSDVarTestBartlett = class(TMLCompSDCondDescDefinition)
                            protected
                            function    getClassOperator: TClassOperator; override;
                            end;

   //oprateur
   TOpSDVarTestBartlett = class(TOpSDCondDescDefinition)
                        protected
                        function    getClassStat(): TClassCalcSDCondDesc; override;
                        function    getClassLstStat(): TClassLstCalcStatDesCond; override;
                        function    getClassParameter: TClassOperatorParameter; override;
                        end;

   //paramtrage
   TOpSDPrmVarTestBartlett = class(TOpPrmSDCondDescDefinition)
                           end;


implementation

USES
   Classes;


{ TMLGenCompSDVarTestBartlett }

procedure TMLGenCompSDVarTestBartlett.GenCompInitializations;
begin
 FMLComp:= mlcDescriptiveStat;

end;

function TMLGenCompSDVarTestBartlett.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompSDVarTestBartlett; 
end;

{ TMLCompSDVarTestBartlett }

function TMLCompSDVarTestBartlett.getClassOperator: TClassOperator;
begin
 result:= TOpSDVarTestBartlett; 
end;

{ TOpSDVarTestBartlett }

function TOpSDVarTestBartlett.getClassLstStat: TClassLstCalcStatDesCond;
begin
 result:= TLstCalcSDVarianceHomogeneityTest;
end;

function TOpSDVarTestBartlett.getClassParameter: TClassOperatorParameter;
begin
 result:= TOpSDPrmVarTestBartlett; 
end;

function TOpSDVarTestBartlett.getClassStat: TClassCalcSDCondDesc;
begin
 result:= TCalcSDVHBartlett;
end;

initialization
 RegisterClass(TMLGenCompSDVarTestBartlett);
end.
