(***************************************************************************)
(* UCompSDVarTestBrownForsythe.pas - Copyright (c) 2005 Ricco RAKOTOMALALA *)
(***************************************************************************)

{
@abstract(Comparaison de K variances -- Test de Brown & Forsythe)
@author(Ricco)
@created(22/07/2005)

Comparaison de K variances (chantillons indpendants bien entendu !)

}

unit UCompSDVarTestBrownForsythe;

interface

USES
   UCompDefinition, UOperatorDefinition,
   UCompSDCondDescDefinition,
   UCalcStatDesConditionnalDesc,
   UCalcStatDesVarianceHomogeneity;

TYPE
   //gnrateur
   TMLGenCompSDVarTestBrownForsythe = class(TMLGenComp)
                               protected
                               procedure   GenCompInitializations(); override;
                               public
                               function    GetClassMLComponent: TClassMLComponent; override;
                               end;

   //composant
   TMLCompSDVarTestBrownForsythe = class(TMLCompSDCondDescDefinition)
                            protected
                            function    getClassOperator: TClassOperator; override;
                            end;

   //oprateur
   TOpSDVarTestBrownForsythe = class(TOpSDCondDescDefinition)
                        protected
                        function    getClassStat(): TClassCalcSDCondDesc; override;
                        function    getClassLstStat(): TClassLstCalcStatDesCond; override;
                        function    getClassParameter: TClassOperatorParameter; override;
                        end;

   //paramtrage
   TOpSDPrmVarTestBrownForsythe = class(TOpPrmSDCondDescDefinition)
                           end;


implementation

USES
   Classes;


{ TMLGenCompSDVarTestBrownForsythe }

procedure TMLGenCompSDVarTestBrownForsythe.GenCompInitializations;
begin
 FMLComp:= mlcDescriptiveStat;

end;

function TMLGenCompSDVarTestBrownForsythe.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompSDVarTestBrownForsythe; 
end;

{ TMLCompSDVarTestBrownForsythe }

function TMLCompSDVarTestBrownForsythe.getClassOperator: TClassOperator;
begin
 result:= TOpSDVarTestBrownForsythe; 
end;

{ TOpSDVarTestBrownForsythe }

function TOpSDVarTestBrownForsythe.getClassLstStat: TClassLstCalcStatDesCond;
begin
 result:= TLstCalcSDVarianceHomogeneityTest;
end;

function TOpSDVarTestBrownForsythe.getClassParameter: TClassOperatorParameter;
begin
 result:= TOpSDPrmVarTestBrownForsythe; 
end;

function TOpSDVarTestBrownForsythe.getClassStat: TClassCalcSDCondDesc;
begin
 result:= TCalcSDVHBrownForsythe;
end;

initialization
 RegisterClass(TMLGenCompSDVarTestBrownForsythe);
end.

