(*********************************************************************)
(* UCompFSRemoveConstant.pas - Copyright (c) 2004 Ricco RAKOTOMALALA *)
(*********************************************************************)

{
@abstract(Supprimer les INPUT les attributs constants, qq soit leur type)
@author(Ricco)
@created(12/05/2004)

Dtecter si sur les individus slectionns, la variable est constant. N'agit que
sur les INPUT, la slection TARGET est ignore.

Trs utile aprs une discrtisation qui aurait chou par exemple (dans le sens
aurait produit 1 seul intervalle).
}

unit UCompFSRemoveConstant;

interface

USES
        Forms, Classes,
        UCompDefinition,
        UCompFSDefinition,
        UCompFSInputSelection,
        UoperatorDefinition;        

TYPE
        {gnrateur}
        TMLGenFSRemoveConstant = class(TMLGenFS)
                                 public
                                 function    GetClassMLComponent: TClassMLComponent; override;
                                 end;

        {composant}
        TMLCompFSRemoveConstant = class(TMLCompFSInputSelection)
                                  protected
                                  function    getClassOperator: TClassOperator; override;
                                  end;

        {oprateur}
        TOpFSRemoveConstant = class(TOperatorFSInputSelection)
                              protected
                              function    getClassParameter: TClassOperatorParameter; override;  
                              public
                              function    CoreExecute(): boolean; override;
                              end;

        {paramtrage de l'oprateur}
        TOpPrmFSRemoveConstant = class(TOpPrmFSInputSelection)
                                 end;
        
implementation

USES
        Sysutils, UDatasetImplementation, UDatasetDefinition,
  UDatasetExamples, UConstConfiguration;

{ TMLCompFSRemoveConstant }

function TMLCompFSRemoveConstant.getClassOperator: TClassOperator;
begin
 result:= TOpFSRemoveConstant; 
end;

{ TOpFSRemoveConstant }

function TOpFSRemoveConstant.CoreExecute: boolean;
var att: TAttribute;
    i,j: integer;
    refValue: TTypeContinue;
    isDiff: boolean;
begin
 result:= TRUE;
 TRY
 //rcuprer chaque variable slectionne et tester
 for j:= 0 to pred(self.WorkData.LstAtts[asInput].Count) do
  begin
   att:= self.WorkData.LstAtts[asInput].Attribute[j];
   //rrrence, la valeur du premier individu slectionn
   isDiff:= FALSE;
   refValue:= att.cValue[outputdata.Examples.Number[1]];
   for i:= 2 to self.WorkData.Examples.Size do
    begin
     if (att.cValue[self.WorkData.Examples.Number[i]]<>refValue)
      then
       begin
        isDiff:= TRUE;
        BREAK;
       end;
    end;
   //alors, alors ???
   if not(isDiff)
    //c'est une constante, il faut la marquer comme " virer"
    then self.RemovedFromInput.AddObject(att.Name,att)
    //sinon, il faut la remettre dans le INPUT
    else self.OutputData.LstAtts[asInput].Add(att);
  end;
 EXCEPT
 result:= FALSE;
 END;
end;

function TOpFSRemoveConstant.getClassParameter: TClassOperatorParameter;
begin
 result:= TOpPrmFSRemoveConstant;
end;

{ TMLGenFSRemoveConstant }

function TMLGenFSRemoveConstant.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompFSRemoveConstant;
end;

initialization
 RegisterClass(TMLGenFSRemoveConstant);
end.
