unit UDlgOpPrmISCAttributeValue;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UDlgBaseOperatorParameter, StdCtrls, ComCtrls, ExtCtrls;

type
  TdlgOpPrmISCAttValue = class(TDlgBaseOperatorParameter)
    cmbAttribute: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    cmbOperator: TComboBox;
    Label3: TLabel;
    edValue: TEdit;
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure   ApplyModifications(); override;
    procedure   SetParameters(); override;    
  end;

var
  dlgOpPrmISCAttValue: TdlgOpPrmISCAttValue;

implementation

uses
    UCompISContinuousAttributeValue,
    UDatasetDefinition,
    UDatasetImplementation;

{$R *.dfm}

{ TdlgOpPrmISCAttValue }

procedure TdlgOpPrmISCAttValue.ApplyModifications;
var prm: TOpPrmISCAttValue;
begin
 prm:= OpPrm as TOpPrmISCAttValue;
 TRY
 prm.AttName:= self.cmbAttribute.Text;
 prm.CondOperator:= self.cmbOperator.ItemIndex;
 prm.Value:= strtofloat(self.edValue.Text);
 EXCEPT
 //valeurs par dfaut
 prm.AttName:= '';
 prm.CondOperator:= 0;
 prm.Value:= 0;
 END;
end;

procedure TdlgOpPrmISCAttValue.SetParameters;
var prm: TOpPrmISCAttValue;
    operator: TOpISCAttValue;
    att: TAttribute;
    j,idAtt: integer;
begin
 prm:= OpPrm as TOpPrmISCAttValue;
 operator:= prm.Operator  as TOpISCAttValue;
 //lister les attributs candidats dans la combo-box
 cmbAttribute.Items.Clear();
 idAtt:= -1;
 for j:= 0 to pred(operator.WorkData.LstAtts[asAll].Count) do
  begin
   att:= operator.WorkData.LstAtts[asAll].Attribute[j];
   if att.isCategory(caContinue)
    then
     begin
       self.cmbAttribute.Items.AddObject(att.Name,att);
       //new -- 18/07/2006 -- mj correctement le numro de l'lment, souci lorsqu'il y avait mlange d'attributs continus et discrets
       if (att.Name = prm.AttName) then idAtt:= pred(self.cmbAttribute.Items.Count);
     end;
  end;
 self.cmbAttribute.ItemIndex:= idAtt;
 //la condition et le seuil
 self.cmbOperator.ItemIndex:= prm.CondOperator;
 self.edValue.Text:= floattostr(prm.Value);
end;

end.
