unit UFrmOpViewRegOutlier;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ComCtrls, ExtCtrls, Grids, UCompRegOutlierDetection;

type
  TfrmOpViewRegOutlier = class(TFrmBaseOperator)
    tabGrid: TTabSheet;
    grid: TDrawGrid;
    procedure gridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure actCopyExecute(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    op: TOpRegOutlier;
    procedure   PrepareView(); override;
  end;

var
  frmOpViewRegOutlier: TfrmOpViewRegOutlier;

implementation

uses UStringAddBuffered, ClipBrd;

{$R *.dfm}

{ TfrmViewRegOutlier }

procedure TfrmOpViewRegOutlier.PrepareView;
begin
 inherited;
 op:= self.Operator as TOpRegOutlier;
 grid.RowCount:= op.WorkData.Examples.Size + 3;
 grid.ColCount:= ord(high(TEnumOutlierDetection)) + 2;
 grid.ColWidths[0]:= 80;
 self.pgctrlFond.ActivePage:= self.tabHTML;
end;

procedure TfrmOpViewRegOutlier.gridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var odr: TEnumOutlierDetection;
    i: integer;
begin
 case ACol of
  //numro d'individu
  0: begin
      if (ARow = 0) then grid.Canvas.TextOut(Rect.Left + 2, Rect.Top + 2,'Statistic');
      if (ARow = 1) then grid.Canvas.TextOut(Rect.Left + 2, Rect.Top + 2,'Lower Bound');
      if (ARow = 2) then grid.Canvas.TextOut(Rect.Left + 2, Rect.Top + 2,'Upper Bound');
      if (ARow > 2) then grid.Canvas.TextOut(Rect.Left + 2, Rect.Top + 2, IntToStr(op.WorkData.Examples.Number[ARow-2]));
     end;
  else
   begin
    odr:= TEnumOutlierDetection(pred(ACol));
    if (ARow = 0) then grid.Canvas.TextOut(Rect.Left + 2, Rect.Top + 2,STR_OUTLIER[odr]);
    if (ARow = 1) then grid.Canvas.TextOut(Rect.Left + 2, Rect.Top + 2,format('%s',[op.descBorne(op.TabBBasse[odr])]));
    if (ARow = 2) then grid.Canvas.TextOut(Rect.Left + 2, Rect.Top + 2,format('%s',[op.descBorne(op.TabBHaute[odr])]));
    if (ARow > 2)
     then
      begin
       i:= ARow-2;
       if op.isOutOfBounds(odr,op.TabValues[i-1,odr])
        then
         begin
          grid.Canvas.Brush.Color:= $0066CCFF;
          grid.Canvas.Brush.Style:= bsSolid;
          grid.Canvas.Rectangle(Rect.Left+1,Rect.Top+1,Rect.Right-1,Rect.Bottom-1);
          grid.Canvas.Brush.Style:= bsClear;
         end;
       grid.Canvas.TextOut(Rect.Left + 4, Rect.Top + 2,format('%.7f',[op.TabValues[i-1,odr]]));
      end;
   end;
 end;
end;

const
    COL_SEPARATOR : CHAR = #9;
    LINE_SEPARATOR : STRING = #13#10;

procedure TfrmOpViewRegOutlier.actCopyExecute(Sender: TObject);
var buf: TBufString;
    i: integer;
    s: string;
    odr: TEnumOutlierDetection;
begin
 if (self.pgctrlFond.ActivePage = tabHTML)
  then inherited
  else
   begin
    screen.Cursor:= crHourGlass;
    TRY
    //copier la grille dans le presse-papier
    buf:= TBufString.Create(1*1024*1024);
    buf.BeginUpdate();
    //les noms des indicateurs statistiques
    s:= 'Statistic';
    for odr:= low(TEnumOutlierDetection) to high(TEnumOutlierDetection) do
     s:= s + COL_SEPARATOR + STR_OUTLIER[odr];
    s:= s + LINE_SEPARATOR;
    buf.AddStr(s);
    //les bornes basses
    s:= 'Lower bound';
    for odr:= low(TEnumOutlierDetection) to high(TEnumOutlierDetection) do
     s:= s + COL_SEPARATOR + op.descBorne(op.TabBBasse[odr]);
    s:= s + LINE_SEPARATOR;
    buf.AddStr(s);
    //les bornes hautes
    s:= 'Upper bound';
    for odr:= low(TEnumOutlierDetection) to high(TEnumOutlierDetection) do
     s:= s + COL_SEPARATOR + op.descBorne(op.TabBHaute[odr]);
    s:= s + LINE_SEPARATOR;
    buf.AddStr(s);
    //les valeurs
    for i:= 1 to op.WorkData.Examples.Size do
     begin
      s:= IntToStr(op.WorkData.Examples.Number[i]);
      for odr:= low(TEnumOutlierDetection) to high(TEnumOutlierDetection) do
       s:= s + COL_SEPARATOR + format('%.8f',[op.TabValues[i-1,odr]]);
      s:= s + LINE_SEPARATOR;
      buf.AddStr(s);
     end;
    //finaliser
    buf.EndUpdate();
    //envoyer dans le presse papier
    clipboard.AsText:= buf.BufS;
    //and then...
    buf.Free();
    FINALLY
    screen.Cursor:= crDefault;
    END;
   end;
end;

end.
