unit UFrmSpvTreeCart;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ComCtrls, ExtCtrls, TeEngine,
  Series, TeeProcs, Chart, LMDCustomComponent, LMDCustomHint,
  LMDCustomShapeHint, LMDShapeHint, LMDMessageHint;

type
  TfrmOpViewSpvTreeCart = class(TFrmBaseOperator)
    tabChart: TTabSheet;
    chart: TChart;
    growing: TLineSeries;
    pruning: TLineSeries;
    msgHint: TLMDMessageHint;
    procedure actCopyExecute(Sender: TObject);
    procedure growingClick(Sender: TChartSeries; ValueIndex: Integer;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure   PrepareView(); override;
  end;

var
  frmOpViewSpvTreeCart: TfrmOpViewSpvTreeCart;

implementation

uses UCompSpvTreeCART, UCalcSpvTreeCART, UCompSpvLDefinition,
  UCompMetaSpvOneInstance;

{$R *.dfm}

procedure TfrmOpViewSpvTreeCart.actCopyExecute(Sender: TObject);
begin
 if (self.pgctrlFond.ActivePageIndex = 0)
  then inherited
  else chart.CopyToClipboardBitmap();
end;

procedure TfrmOpViewSpvTreeCart.PrepareView;
var arbre: TMLTreeStructureSpvCART;
    i: integer;
begin
 inherited;
 //assurer le coup avant de se lancer
 if (Operator is TOpOneInstance) and ((Operator as TOpOneInstance).Classifier is TCalcSpvTreeCART)
  then
   begin
    //rcuprer le tableau des taux d'erreur et du nombre de feuilles
    arbre:= ((Operator as TOpOneInstance).Classifier as TCalcSpvTreeCART).Tree as TMLTreeStructureSpvCART;
    for i:= high(arbre.TabTreeSequence) downto low(arbre.TabTreeSequence) do
     begin
      growing.AddXY(arbre.TabTreeSequence[i].NbLeaves,arbre.TabTreeSequence[i].ErrGrow);
      pruning.AddXY(arbre.TabTreeSequence[i].NbLeaves,arbre.TabTreeSequence[i].ErrPrune);
     end;
   end;
 //slectionner la sortie HTML
 self.pgctrlFond.ActivePageIndex:= 0;
end;

procedure TfrmOpViewSpvTreeCart.growingClick(Sender: TChartSeries;
  ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
var coord: TPoint;
    msg: string;
begin
 coord:= chart.ClientToScreen(point(X,Y));
 msg:= Format('# leaves : %.0f -- Err. rate : %.4f',[sender.XValues[ValueIndex],sender.YValues[ValueIndex]]);
 msgHint.ShowMessage(msg,coord.X,coord.Y);
end;

end.
