unit UFrmOpVarClusHCA;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ComCtrls, ExtCtrls, TeEngine,
  Series, TeeProcs, Chart, UCompVarClusHCA, LMDCustomComponent,
  LMDCustomHint, LMDCustomShapeHint, LMDMessageHint;

type
  TFrmOpViewVarClusHCA = class(TFrmBaseOperator)
    tabDendrogram: TTabSheet;
    chart: TChart;
    dendrogram: TPointSeries;
    messageHint: TLMDMessageHint;
    procedure chartClickSeries(Sender: TCustomChart; Series: TChartSeries;
      ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure chartClickBackground(Sender: TCustomChart;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure pgctrlFondChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure actCopyExecute(Sender: TObject);
  private
    { Dclarations prives }
    procedure drawDendro(Sender: TObject);
    procedure drawToLeaves(node: TNodeHCA);
  public
    { Dclarations publiques }
    FCalc: TCalcHCA;
    procedure   PrepareView(); override;
  end;

var
  FrmOpViewVarClusHCA: TFrmOpViewVarClusHCA;

implementation

uses UCompVarClusBase;

{$R *.dfm}

procedure TFrmOpViewVarClusHCA.drawDendro(Sender: TObject);
begin
 chart.Canvas.Pen.Color:= clBlue;
 chart.Canvas.Pen.Width:= 2;
 self.drawToLeaves(FCalc.SetNodeHCA.RootNode);
end;

procedure TFrmOpViewVarClusHCA.drawToLeaves(node: TNodeHCA);
var sommet,left,right: TPoint;

   function coord(node: TNodeHCA): TPoint;
   begin
    result:= Point(dendrogram.CalcXPosValue(node.XPos),dendrogram.CalcYPosValue(node.YPos));
   end;

begin
 //pas une feuille ?
 if not(node.isLeaf())
  then
   begin
    sommet:= coord(node);
    left:= coord(node.ChildL);
    right:= coord(node.ChildR);
    chart.Canvas.Line(sommet.X,sommet.Y,left.X,sommet.Y);
    chart.Canvas.Line(left.X,sommet.Y,left.X,left.Y);
    chart.Canvas.Line(sommet.X,sommet.Y,right.X,sommet.Y);
    chart.Canvas.Line(right.X,sommet.Y,right.X,right.Y);
    //dessiner sur les feuilles
    self.drawToLeaves(node.ChildL);
    self.drawToLeaves(node.ChildR);
   end;
end;

procedure TFrmOpViewVarClusHCA.PrepareView;
var i: integer;
    node: TNodeHCA;
begin
 inherited;
 //rcuprer l'oprateur de calcul -- bien transtyper pour prvenir les erreurs
 FCalc:= (self.Operator as TOpVarClusBase).Calc as TCalcHCA;
 //modifier la page active
 self.pgctrlFond.ActivePage:= self.tabHTML;
 //remplir le graphique
 dendrogram.Clear();
 for i:= 0 to pred(FCalc.SetNodeHCA.getCountNodes()) do
  begin
   node:= FCalc.SetNodeHCA.getNode(i);
   if node.isCluster
    then dendrogram.AddXY(node.XPos,node.YPos,node.getLabel(),clWhite)
    else dendrogram.AddXY(node.XPos,node.YPos,node.getLabel(),clBlue);
  end;
 //gestionnaire de dessin du dendrogramme
 //dendrogram.AfterDrawValues:= drawDendro;
 //>>new -- 19/07/2006 -- pas mal a, on distingue mieux les noeuds !!!
 dendrogram.BeforeDrawValues:= drawDendro;
end;

procedure TFrmOpViewVarClusHCA.chartClickSeries(Sender: TCustomChart;
  Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var coord: TPoint;
begin
 if (Series = dendrogram) and (ValueIndex >= 0)
  then
   begin
    coord:= chart.ClientToScreen(point(X,Y));
    messageHint.ShowMessage(dendrogram.ValueMarkText[ValueIndex],coord.X,coord.Y);
   end;
end;

procedure TFrmOpViewVarClusHCA.chartClickBackground(Sender: TCustomChart;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 messageHint.HideMessage();
end;

procedure TFrmOpViewVarClusHCA.pgctrlFondChange(Sender: TObject);
begin
 messageHint.HideMessage();
end;

procedure TFrmOpViewVarClusHCA.FormActivate(Sender: TObject);
begin
 Application.OnDeactivate:= pgctrlFondChange;
end;

procedure TFrmOpViewVarClusHCA.FormDeactivate(Sender: TObject);
begin
 messageHint.HideMessage();
 Application.OnDeactivate:= nil;
end;

procedure TFrmOpViewVarClusHCA.actCopyExecute(Sender: TObject);
begin
 if (self.pgctrlFond.ActivePageIndex = 0)
  then inherited
  else self.chart.CopyToClipboardMetafile(false);
end;

end.
