unit UFrmOpViewVarClusTopDown;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ComCtrls, ExtCtrls, TeEngine,
  Series, TeeProcs, Chart, UCompVarClusTopDown, LMDCustomComponent,
  LMDCustomHint, LMDCustomShapeHint, LMDMessageHint;

type
  TFrmOpViewVarClusTopDown = class(TFrmBaseOperator)
    tabDendrogram: TTabSheet;
    chart: TChart;
    dendrogram: TPointSeries;
    messageHint: TLMDMessageHint;
    procedure chartClickSeries(Sender: TCustomChart; Series: TChartSeries;
      ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure chartClickBackground(Sender: TCustomChart;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormResize(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure actCopyExecute(Sender: TObject);
  private
    { Dclarations prives }
    procedure drawDendro(Sender: TObject);
    procedure drawToLeaves(node: TNodeTD);
  public
    { Dclarations publiques }
    FCalc: TCalcVarClusTD;
    procedure   PrepareView(); override;    
  end;

var
  FrmOpViewVarClusTopDown: TFrmOpViewVarClusTopDown;

implementation

uses UCalcVarClusBase, UCompVarClusBase;

{$R *.dfm}

{ TFrmOpViewVarClusTopDown }

procedure TFrmOpViewVarClusTopDown.drawDendro(Sender: TObject);
begin
 chart.Canvas.Pen.Color:= clBlue;
 chart.Canvas.Pen.Width:= 2;
 self.drawToLeaves(FCalc.SetNode.FRoot);
end;

procedure TFrmOpViewVarClusTopDown.drawToLeaves(node: TNodeTD);
var sommet,left,right: TPoint;

   function coord(node: TNodeTD): TPoint;
   begin
    result:= Point(dendrogram.CalcXPosValue(node.XPos),dendrogram.CalcYPosValue(node.YPos));
   end;

begin
 //pas une feuille ?
 if not(node.isLeaf())
  then
   begin
    sommet:= coord(node);
    left:= coord(node.LeftChild);
    right:= coord(node.RightChild);
    chart.Canvas.Line(sommet.X,sommet.Y,left.X,sommet.Y);
    chart.Canvas.Line(left.X,sommet.Y,left.X,left.Y);
    chart.Canvas.Line(sommet.X,sommet.Y,right.X,sommet.Y);
    chart.Canvas.Line(right.X,sommet.Y,right.X,right.Y);
    //dessiner sur les feuilles
    self.drawToLeaves(node.LeftChild);
    self.drawToLeaves(node.RightChild);
   end;
end;

procedure TFrmOpViewVarClusTopDown.PrepareView;
var i: integer;
    node: TNodeTD;
    maxY, maxX: single;
begin
 inherited;
 //rcuprer l'oprateur de calcul -- bien transtyper pour prvenir les erreurs
 FCalc:= (self.Operator as TOpVarClusBase).Calc as TCalcVarClusTD;
 //modifier la page active
 self.pgctrlFond.ActivePage:= self.tabHTML;
 //remplir le graphique
 dendrogram.Clear();
 maxY:= 0.0; maxX:= 0.0;
 for i:= 0 to pred(FCalc.SetNode.FSequence.Count) do
  begin
   node:= FCalc.SetNode.FSequence[i] as TNodeTD;
   if (node.YPos > maxY) then maxY:= node.YPos;
   if (node.XPos > maxX) then maxX:= node.XPos;   
   if (node.isCluster = true)
    then dendrogram.AddXY(node.XPos,node.YPos,node.getLabel(),clWhite)
    else dendrogram.AddXY(node.XPos,node.YPos,node.getLabel(),clBlue);
  end;
 //mj des axes
 (*
 chart.LeftAxis.Automatic:= false;
 chart.LeftAxis.Minimum:= 0.0 - 0.05;
 chart.LeftAxis.Maximum:= maxY + 0.1;
 chart.BottomAxis.Automatic:= false;
 chart.BottomAxis.Minimum:= 0.0 - 0.3;
 chart.BottomAxis.Maximum:= maxX + 0.3;
 *)
 //gestionnaire de dessin du dendrogramme
 dendrogram.BeforeDrawValues:= drawDendro;
end;

procedure TFrmOpViewVarClusTopDown.chartClickSeries(Sender: TCustomChart;
  Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var coord: TPoint;  
begin
 if (Series = dendrogram) and (ValueIndex >= 0)
  then
   begin
    coord:= chart.ClientToScreen(point(X,Y));
    messageHint.ShowMessage(dendrogram.ValueMarkText[ValueIndex],coord.X,coord.Y);
   end;
end;

procedure TFrmOpViewVarClusTopDown.chartClickBackground(
  Sender: TCustomChart; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
 messageHint.HideMessage();
end;

procedure TFrmOpViewVarClusTopDown.FormResize(Sender: TObject);
begin
 messageHint.HideMessage();
end;

procedure TFrmOpViewVarClusTopDown.FormDeactivate(Sender: TObject);
begin
 messageHint.HideMessage();
 Application.OnDeactivate:= nil;
end;

procedure TFrmOpViewVarClusTopDown.FormActivate(Sender: TObject);
begin
 Application.OnDeactivate:= FormResize;
end;

procedure TFrmOpViewVarClusTopDown.actCopyExecute(Sender: TObject);
begin
 if (self.pgctrlFond.ActivePageIndex = 0)
  then inherited
  else self.chart.CopyToClipboardMetafile(false);
end;

end.
