(********************************************************************************)
(* UFrmOpViewCorrelationScatterplot.pas - Copyright (c) 2004 Ricco RAKOTOMALALA *)
(********************************************************************************)

unit UFrmOpViewCorrelationScatterplot;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ExtCtrls, OleCtrls,
  ComCtrls, TeEngine, Series, TeeProcs, Chart;

type
  TFrmOpViewCorrelationScatterplot = class(TFrmBaseOperator)
    tabChart: TTabSheet;
    chart: TChart;
    scatter: TPointSeries;
    actFontSizeIncrease: TAction;
    actFontSizeDecrease: TAction;
    N1: TMenuItem;
    Font1: TMenuItem;
    Font2: TMenuItem;
    procedure actCopyExecute(Sender: TObject);
    procedure chartBeforeDrawSeries(Sender: TObject);
    procedure actFontSizeIncreaseExecute(Sender: TObject);
    procedure actFontSizeDecreaseExecute(Sender: TObject);
  private
  public
  procedure   PrepareView(); override;
  end;

var
  FrmOpViewCorrelationScatterplot: TFrmOpViewCorrelationScatterplot;

implementation

uses UCalcStatDesCorrelation, UCompViewCorrelationScatter;

{$R *.dfm}

{ TFrmOpViewCorrelationScatterplot }

procedure TFrmOpViewCorrelationScatterplot.PrepareView;
var op: TOpCorrelationScatter;
    cx1,cx2: TCalcSDCorrelation;
    i: integer;
begin
 op:= operator as TOpCorrelationScatter;
 chart.Title.Text.Text:= format('Correlation scatterplot (%s vs. %s)',[op.X1.Name,op.X2.Name]);
 chart.BottomAxis.Title.Caption:= op.X1.Name;
 chart.LeftAxis.Title.Caption:= op.X2.Name;
 scatter.Clear;
 for i:= 0 to pred(op.LstX1.Count) do
  begin
   cx1:= TCalcSDCorrelation(op.LstX1.Stat(i));
   cx2:= TCalcSDCorrelation(op.LstX2.Stat(i));
   scatter.AddXY(cx1.R,cx2.R,cx1.XAtt.Name,clTeeColor);
  end;
end;

procedure TFrmOpViewCorrelationScatterplot.actCopyExecute(Sender: TObject);
begin
 chart.CopyToClipboardMetafile(false);
end;

procedure TFrmOpViewCorrelationScatterplot.chartBeforeDrawSeries(
  Sender: TObject);
var r: TRect;
begin
 //coordonnes
 r.Left:= scatter.CalcXPosValue(-1.0);
 r.Top:= scatter.CalcYPosValue(-1.0);
 r.Right:= scatter.CalcXPosValue(+1.0);
 r.Bottom:= scatter.CalcYPosValue(+1.0);
 //dessiner le cercle
 chart.Canvas.Pen.Width:= 2;
 chart.Canvas.Pen.Color:= clBlue;
 chart.Canvas.Pen.Style:= psDash;
 chart.Canvas.Ellipse(r.Left,r.Top,r.Right,r.Bottom);
 //les axes
 chart.Canvas.Pen.Width:= 2;
 chart.Canvas.Pen.Color:= clBlack;
 r.Top:= scatter.CalcYPosValue(0.0);
 chart.Canvas.Line(r.Left,r.Top,r.Right,r.Top);
 r.Top:= scatter.CalcYPosValue(-1.0);
 r.Left:= scatter.CalcXPosValue(0.0);
 chart.Canvas.Line(r.Left,r.Top,r.Left,r.Bottom);
end;

procedure TFrmOpViewCorrelationScatterplot.actFontSizeIncreaseExecute(
  Sender: TObject);
begin
 scatter.Marks.Font.Size:= scatter.Marks.Font.Size + 1;
end;

procedure TFrmOpViewCorrelationScatterplot.actFontSizeDecreaseExecute(
  Sender: TObject);
begin
 scatter.Marks.Font.Size:= scatter.Marks.Font.Size - 1;
end;

end.
