(**************************************************************************)
(* UCompViewScatterPlotLegend.pas - Copyright (c) 2007 Ricco RAKOTOMALALA *)
(**************************************************************************)

{
@abstract(Voir les donnes sous forme de scatterplot avec une lgende)
@author(Ricco)
@created(02/02/2007)

La lgende peut tre :
---------------------
(1) le numro d'un individu
(2) la valeur de X ; Y
(3) la valeur d'une variable discrte

}
unit UCompViewScatterPlotLegend;

interface

USES
        Forms,
        UCompDefinition,
        UCompManageDataset,
        UOperatorDefinition,
        UDatasetImplementation;

TYPE
        {Gnrateur de composant de visualisation}
        TMLGenCompScatterPlotLegend = class(TMLGenComp)
        protected
        procedure   GenCompInitializations(); override;
        public
        function    GetClassMLComponent: TClassMLComponent; override;
        end;

        {le composant de visualisation}
        TMLCompScatterPlotLegend = class(TMLCompLocalData)
        protected
        function    getClassOperator: TClassOperator; override;
        end;

        {l'oprateur de visualisation}
        TOpScatterPlotLegend = class(TOpLocalData)
        protected
        function    getClassParameter: TClassOperatorParameter; override;
        function    getNewForm(): TForm; override;
        {pas de lancement de calcul ici}
        function    CoreExecute(): boolean; override;
        public
        end;

        {paramtrage de l'oprateur de visualisation}
        TOpPrmScatterPlotLegend = class(TOperatorParameter)
        protected
        procedure   SetDefaultParameters(); override;
        function    CreateDlgParameters(): TForm; override;
        procedure   GetParameters(var prmModif: boolean); override;
        end;


implementation

uses
    Classes, UFrmOpScatterLegend;

{ TMLGenCompScatterPlotLegend }

procedure TMLGenCompScatterPlotLegend.GenCompInitializations;
begin
 FMLComp:= mlcDataView;
end;

function TMLGenCompScatterPlotLegend.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompScatterPlotLegend;
end;

{ TMLCompScatterPlotLegend }

function TMLCompScatterPlotLegend.getClassOperator: TClassOperator;
begin
 result:= TOpScatterPlotLegend;
end;

{ TOpScatterPlotLegend }

function TOpScatterPlotLegend.CoreExecute: boolean;
begin
 result:= TRUE;
end;

function TOpScatterPlotLegend.getClassParameter: TClassOperatorParameter;
begin
 result:= TOpPrmScatterPlotLegend; 
end;

function TOpScatterPlotLegend.getNewForm: TForm;
begin
 result:= TFrmOpViewScatterLegend.CreateFromOperator(self);
end;

{ TOpPrmScatterPlotLegend }

function TOpPrmScatterPlotLegend.CreateDlgParameters: TForm;
begin
 result:= nil;
end;

procedure TOpPrmScatterPlotLegend.GetParameters(var prmModif: boolean);
begin
 inherited GetParameters(prmModif);
 //pas d'invalidation de la suite du diagramme
 prmModif:= FALSE;
end;

procedure TOpPrmScatterPlotLegend.SetDefaultParameters;
begin
 //none
end;

initialization
 RegisterClass(TMLGenCompScatterPlotLegend);
end.
