unit UFrmOpScatterLegend;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ComCtrls, ExtCtrls, StdCtrls,
  TeEngine, Series, TeeProcs, Chart, UDatasetImplementation;

type
  TFrmOpViewScatterLegend = class(TFrmBaseOperator)
    Panel1: TPanel;
    Panel2: TPanel;
    panelChart: TPanel;
    chart: TChart;
    Series1: TPointSeries;
    cmbX2: TComboBox;
    cmbX1: TComboBox;
    gbLegend: TGroupBox;
    rbExampleId: TRadioButton;
    rbXYValues: TRadioButton;
    rbAttribute: TRadioButton;
    cmbAttribute: TComboBox;
    Label1: TLabel;
    Panel3: TPanel;
    TabSheet1: TTabSheet;
    actFontIn: TAction;
    actFontOut: TAction;
    N1: TMenuItem;
    actFontIn1: TMenuItem;
    actFontOut1: TMenuItem;
    procedure cmbX1Change(Sender: TObject);
    procedure rbExampleIdClick(Sender: TObject);
    procedure actCopyExecute(Sender: TObject);
    procedure actFontInExecute(Sender: TObject);
    procedure actFontOutExecute(Sender: TObject);
  private
    { Dclarations prives }
    //donnes  visualiser
    FData: TMLDataset;
    //rafrachissement  la vole ?
    FOkRefresh: boolean;
    //recalculer le graphique
    procedure   RefreshChart();
    //gestionnaire d'affichage des marques
    procedure GetMark(Sender : TChartSeries; ValueIndex : Longint;  Var MarkText : String);
  public
    { Dclarations publiques }
    //prparation de l'affichage
    procedure   PrepareView(); override;
  end;

var
  FrmOpViewScatterLegend: TFrmOpViewScatterLegend;

implementation

uses
    UCompViewScatterPlotLegend, UDatasetDefinition;

{$R *.dfm}

{ TFrmOpViewScatterLegend }

procedure TFrmOpViewScatterLegend.PrepareView;
var j: integer;
    att: TAttribute;
begin
 //connecter les donnes
 FData:= (Operator as TOpScatterPlotLegend).Workdata;
 //dimensionner la srie
 self.Series1.FillSampleValues(FData.Examples.Size);
 //lister les variables discrtes
 for j:= 0 to pred(FData.LstAtts[asAll].Count) do
  begin
   att:= FData.LstAtts[asAll].Attribute[j];
   if att.isCategory(caContinue)
    then
     begin
      cmbX1.Items.AddObject(att.Name,att);
      cmbX2.Items.AddObject(att.Name,att);
     end
    else cmbAttribute.Items.AddObject(att.Name,att);
  end;
 //tester si pas de variables discrtes
 if (cmbAttribute.Items.Count = 0)
  then
   begin
    cmbAttribute.Enabled:= false;
    self.rbAttribute.Enabled:= false;
   end
  else cmbAttribute.ItemIndex:= 0;
 FOkRefresh:= FALSE;
 //provoquer la premire slection
 cmbX1.ItemIndex:= 0;
 cmbX2.ItemIndex:= 0;
 //rafrachir l'affichage
 FOkRefresh:= TRUE;
 self.RefreshChart();
 //brancher le gestionnaire d'vnement
 self.Series1.OnGetMarkText:= GetMark;
end;

procedure TFrmOpViewScatterLegend.RefreshChart();
var att1, att2: TAttribute;
    example,i: integer;
begin
 att1:= cmbX1.Items.Objects[cmbX1.ItemIndex] as TAttribute;
 att2:= cmbX2.Items.Objects[cmbX2.ItemIndex] as TAttribute;
 self.chart.Title.Text.Text:= att1.Name + ' vs. ' + att2.Name;
 chart.BottomAxis.Title.Caption:= att1.Name;
 chart.LeftAxis.Title.Caption:= att2.Name;
 for i:= 1 to FData.Examples.Size do
  begin
   example:= FData.Examples.Number[i];
   series1.XValue[pred(i)]:= att1.cValue[example];
   series1.YValue[pred(i)]:= att2.cValue[example];
  end;
end;

procedure TFrmOpViewScatterLegend.cmbX1Change(Sender: TObject);
begin
 if (FOkRefresh = true)
  then self.RefreshChart();
end;

procedure TFrmOpViewScatterLegend.GetMark(Sender: TChartSeries;
  ValueIndex: Integer; var MarkText: String);
var att: TAttribute;
    id: integer;
begin
 //ID ?
 if (self.rbExampleId.Checked = true)
  then MarkText:= IntToStr(FData.Examples.Number[succ(ValueIndex)])
  else
   begin
    //valeur X, Y ?
    if (self.rbXYValues.Checked = true)
     then MarkText:= Format('%.2f ; %.2f',[series1.XValue[ValueIndex],series1.YValue[ValueIndex]])
     else
      //prendre une variable comme ref.
      begin
       id:= FData.Examples.Number[succ(ValueIndex)];
       att:= cmbAttribute.Items.Objects[cmbAttribute.ItemIndex] as TAttribute;
       MarkText:= att.sValue[id];
      end;
   end;
end;

procedure TFrmOpViewScatterLegend.rbExampleIdClick(Sender: TObject);
begin
 //demander le rafrachissement de l'affichage
 chart.Refresh();
end;

procedure TFrmOpViewScatterLegend.actCopyExecute(Sender: TObject);
begin
 chart.CopyToClipboardMetafile(false);
end;

procedure TFrmOpViewScatterLegend.actFontInExecute(Sender: TObject);
begin
 self.Series1.Marks.Font.Size:= self.Series1.Marks.Font.Size + 1;
end;

procedure TFrmOpViewScatterLegend.actFontOutExecute(Sender: TObject);
begin
 self.Series1.Marks.Font.Size:= self.Series1.Marks.Font.Size - 1;
end;

end.
