(****************************************************************)
(* UConstConfigHint.pas - Copyright (c) 2006 Ricco RAKOTOMALALA *)
(****************************************************************)

{
@abstract(Classe d'affichage des HINT pour la description des mthodes)
@author(Ricco)
@created(23/10/2006)

@modif(26/07/2007) add modifications suggested by Armgong (thanks a lot)
}
unit UConstConfigHint;

interface

USES

    Controls, Classes, Types, HTMLLite, ExtCtrls;

CONST

    //fonte d'affichage des hint
    HINT_FONT_NAME = 'Microsoft Sans Serif';

    //taille des hint
    HINT_FONT_SIZE = 8;

    //largeur de fentre de Hint
    HINT_WINDOW_MAX_WIDTH = 350;

    //dcalage vers le haut pour ne pas masquer les autes composants
    HINT_WINDOW_TOP_DECALAGE = 180;



TYPE
    //classe de Hint pour Tanagra
    TTanagraHintClass = class(THintWindow)
    protected
    FPanel: TPanel;
    FHtml: ThtmlLite;
    procedure Paint; override;
    public
    //spcifier les paramtres
    constructor create(AOwner: TComponent); override;
    destructor  destroy(); override; //add by armgong
    function CalcHintRect(MaxWidth: Integer; const AHint: string; AData: Pointer): TRect; override;
    procedure ActivateHint(Rect: TRect; const AHint: string); override;
    end;

implementation

USES
    Graphics, StdCtrls;

VAR
    oldHint : string;//add by armgong

{ TTanagraHint }

procedure TTanagraHintClass.ActivateHint(Rect: TRect; const AHint: string);
begin
 //dcalage d'abord
 Rect.Top:= Rect.Top - HINT_WINDOW_TOP_DECALAGE;
 Rect.Bottom:= Rect.Bottom - HINT_WINDOW_TOP_DECALAGE;
 if oldhint<>ahint then //add by armgong
 begin
  inherited;
  FHtml.Clear;
  FHtml.LoadFromString(AHint,'');
  oldhint:=ahint;
 end //add end
 (*
 //prparation affichage du fond
 inherited;
 //rcupration du message
 FHtml.Clear;
 FHtml.LoadFromString(AHint,'');
 *)
end;

function TTanagraHintClass.CalcHintRect(MaxWidth: Integer;
  const AHint: string; AData: Pointer): TRect;
var r: TRect;
begin
 r:= inherited CalcHintRect(HINT_WINDOW_MAX_WIDTH, AHint, AData);
 r.Top:= r.Top - HINT_WINDOW_TOP_DECALAGE;
 r.Bottom:= r.Bottom - HINT_WINDOW_TOP_DECALAGE;
 //
 result:= r;
end;

constructor TTanagraHintClass.create(AOwner: TComponent);
begin
 inherited;
 //paramtres d'affichage des hint
 Canvas.Font.Name := HINT_FONT_NAME;
 Canvas.Font.Size := HINT_FONT_SIZE;
 //viewer HTML
 FPanel:= TPanel.Create(self);
 FPanel.Parent:= self;
 FPanel.Align:= alClient;

 FHtml:= ThtmlLite.Create(FPanel);
 FHtml.DefBackground:= clInfoBk;
 FHtml.Parent:= FPanel;
 FHtml.Align:= alClient;
 FHtml.ScrollBars:= ssNone;
 FHtml.BorderStyle:= htNone;
 FHtml.DefFontName:= HINT_FONT_NAME;
 FHtml.DefFontSize:= HINT_FONT_SIZE;
 Fhtml.DefFontColor:= clBlack;

 //FHtml.htOptions:= 
end;

destructor TTanagraHintClass.destroy;
begin
  FHtml.free;
  FPanel.free;
  inherited;
end;

procedure TTanagraHintClass.Paint;
begin
 //FHtml.Refresh();
 FPanel.PaintTo(self.Canvas,0,0);
end;

end.
