(***************************************************************)
(* UBatchExecution.pas - Copyright (c) 2004 Ricco RAKOTOMALALA *)
(***************************************************************)

{
@abstract(Excution en mode BATCH)
@author(Ricco)
@created(13/10/2004)

Charger la filire courante, lancer son excution et fermer l'application !!!
}

unit UBatchExecution;

interface

TYPE
        TEnum_ERR_BatchMode = (bmNoError, bmDiagramNotFound, bmErrorExecution);

        TEnum_Mode_Batch_Execution = (bmeNone, bmeStandard, bmeExcel);

CONST
        MSG_ERR_BatchMode : array[TEnum_ERR_BatchMode] of string =
                            ('No error in batch mode','Diagram file not found','Error during batch execution');

        BATCH_MODE_EXECUTION : Boolean = FALSE;

        STR_IDENT_INI_BUILD_REPORT = 'Build_Report';

VAR
        FILE_DIAGRAM_FROM_EXCEL : string;        
        
{procdure globale, responsable de l'excution en mode batch}
function RunBatchMode(): TEnum_ERR_BatchMode;

//new -- 20/11/2006 -- dtecter le type de batch demand
function  detectBatchExecution(): TEnum_Mode_Batch_Execution;
//new -- 20/11/2006 -- excution standard batch -- ancienne procdure
procedure executeStandardBatchMode();
//new -- 20/11/2006 - excuter le mode batch  partir d'Excel
procedure executeExcelBatchMode();

implementation

USES
        SysUtils, Forms, ClipBrd, Windows, IniFiles, Dialogs,
        ULogFile, UCompDefinition, UFrmMainForm, UFrmPaletteGenComponents,
        UMLDiagramReport, UConstConfiguration;

//new -- 20/11/2006 -- dtecter le type de batch demand
function  detectBatchExecution(): TEnum_Mode_Batch_Execution;
begin
 if (paramCount = 1)
  then
   begin
    if (paramStr(1) = 'excel_tanagra_execution')
     then result:= bmeExcel
     else result:= bmeStandard;
   end
  else result:= bmeNone;
end;

//new -- 20/11/2006 -- execution batch avec .tdm et .bdm
procedure executeStandardBatchMode();
var  errBatchMode: TEnum_ERR_BatchMode;
begin
 TRY
 errBatchMode:= RunBatchMode();
 if (errBatchMode <> bmNoError)
  then TraceLog.WriteToLogFile('[BATCH MODE], !!! ERROR EXECUTION !!! --> '+MSG_ERR_BatchMode[errBatchMode]);
 //quoiqu'il en soit, c'est relche...
 Application.Terminate();
 EXCEPT
 TraceLog.WriteToLogFile('[BATCH MODE] --> WARNING !!! Error occurs at Application.Terminate()');
 END;
end;

function RunBatchMode(): TEnum_ERR_BatchMode;
var sFileName,sFileReport: string;
    diagram: TMLDiagram;
    report: TMLDgmReport;
begin
 //mode batch en cours donc...
 BATCH_MODE_EXECUTION:= TRUE;
 //---------------------------
 result:= bmNoError;
 //rcuprer le nom de filire et analyser son intgrit
 sFileName:= ParamStr(1);
 sFileName:= ExpandUNCFileName(sFileName);
 if not(FileExists(sFileName))
  then result:= bmDiagramNotFound
  else
   begin
    TRY
     TraceLog.WriteToLogFile(format('[BATCH MODE] << BEGIN, analyse du diagramme "%s"',[sFileName]));
     //cacher la fentre principale
     frmMain.Hide();
     //charger -- excuter
     diagram:= TMLDiagram.CreateFromFile(frmMain,frmPaletteComp.imglstMLComponents,sFileName);
     diagram.FullExecute();
     //gnrer automatiquement le rapport, sans le faire apparatre
     sFileReport:= ChangeFileExt(sFileName,'.html');
     diagram.HTMLFileName:= sFileReport;//!!! pas trs catholique mais si rellement on ne peut pas faire autrement !!!
     //new -- 05/02/2005
     //test si rapport demand
     if not(assigned(TanagraParameters)) or (assigned(TanagraParameters) and (TanagraParameters.ReadInteger('BATCH_MODE',STR_IDENT_INI_BUILD_REPORT,0)=1))
      then
       begin
         report:= TMLDgmReport.create(diagram);
         report.WriteReport();
         //librer
         report.Free();
       end;
     diagram.Free();
     //debugfile...
     TraceLog.WriteToLogFile('[BATCH MODE] END >>');
    EXCEPT
     result:= bmErrorExecution;
    END;
   end;
end;

{une procdure simple pour obtenir un nom de fichier dans le rpertoire temporaire}
function  getTmpFileName(prefix: string): string;
Var Path, FileName : Array[0..1024] Of Char ;
begin
 // Rcupration du rpertoire temporaire (ventuellement, celui de l'application).
 If (GetTempPath(MAX_PATH,@Path)=0) Then
    StrCopy(@Path,PChar(ExtractFileDir(Application.ExeName)));
 // Cration d'un fichier temporaire unique.
 If (GetTempFileName(@Path,PChar(prefix),0,@FileName)=0)
  Then result:= ''
  Else result:= StrPas(FileName);
end;

//new -- 20/11/2006 - excuter le mode batch  partir d'Excel
procedure executeExcelBatchMode();
var data, fileData: string;
    f: TextFile;
    mem: TMemInifile;
begin
 TraceLog.WriteToLogFile('[BATCH] execute excel batch mode...');
 //rcuprer les donnes en provenance du clipboard et les sauver dans un fichier temporaire
 data:= clipboard.AsText;
 if (data = '')
  then
   begin
    MessageDlg('No dataset from the spreadsheet. Please check the range selection',mtError,[mbOk],0);
    Application.Terminate;
   end
  else
   begin
    fileData:= getTmpFileName('tanagra_dataset');
    fileData:= ChangeFileExt(fileData,'.txt');
    assignFile(f,fileData);
    rewrite(f);
    write(f,data);
    closeFile(f);
    //former le diagramme
    FILE_DIAGRAM_FROM_EXCEL:= ChangeFileExt(fileData,'.tdm');
    mem:= TMemIniFile.Create(FILE_DIAGRAM_FROM_EXCEL);
    mem.WriteString('Diagram','Title','Analysis');
    mem.WriteString('Diagram','Database',fileData);
    mem.UpdateFile();
    mem.Free();
    //lancer l'application
    Application.Run();
    //ouvrir le diagramme
    TraceLog.WriteToLogFile(format('[EXCEL], open the diagram = %s, and dataset = %s',[FILE_DIAGRAM_FROM_EXCEL,fileData]));
   end;
end;


end.
